/*
* Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This component and the accompanying materials are made available
* under the terms of "Eclipse Public License v1.0"
* which accompanies this distribution, and is available
* at the URL "http://www.eclipse.org/legal/epl-v10.html".
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/
#ifndef TESTAFSTORAGEPROXY_H
#define TESTAFSTORAGEPROXY_H

#include <QObject>
#include <QPixmap>

class AfStorageProxy;

class TestAfStorageProxy : public QObject
{
    Q_OBJECT

private slots:
    void init();
    void cleanup();
    
//    void testConstructorThrowsWhenStorageConstructionLeaves();
//    void testMethodsReturnFalseInCaseOfErrorsInStorage();
    
    void testSaveActivityDataSerialization();
    void testSaveActivityFlags();
    void testSaveActivityScreenshotHandle();
    
    void testDeprecatedAddAndUpdateMethods();
    
    void testRemoveActivity();
    void testRemoveApplicationActivities();
    void testWaitActivity();
    void testLaunchActivity();
    void testGetThumbnail();
    void testNotifyDataChange();
    void testActivities();
    void testApplicationActivities();
    void testActivityData();
    void testActivityMetaData();

private:
    QPixmap generateNonNullScreenshot();
    
private:
    AfStorageProxy *mProxy;
};

#endif // TESTAFSTORAGEPROXY_H
