/*
* Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This component and the accompanying materials are made available
* under the terms of "Eclipse Public License v1.0"
* which accompanies this distribution, and is available
* at the URL "http://www.eclipse.org/legal/epl-v10.html".
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/
#include "unittest_activityclient.h"

#include <QtTest/QtTest>
#include <QVariant>

#include "afclient.h"
#include "afactivitystorage.h"
#include "afactivation.h"

const char DefaultActivityName [] = "DefaultTestActivityName";
const char DefaultActivityPrivate [] = "DefaultTestActivityPrivateData";
const char DefaultActivityPublic [] = "DefaultTestActivityPublicData";
const char DefaultActivityPublicKey [] = "FakeData";

void TestActivityClient::testAllMethods()
{
    // prepare test data
    RProcess process;
    const int applicationId(process.SecureId().iId);
    QString activityId(DefaultActivityName);
    QVariant privateData(DefaultActivityPrivate);
    QVariantHash publicData;
    publicData.insert(DefaultActivityPublicKey, QVariant(DefaultActivityPublic));

    // create object under test
    AfClient *mClient = new AfClient(QSharedPointer<AfActivityStorage>(new AfActivityStorage()), QSharedPointer<AfActivation>(new AfActivation()));

    // invoke all methods
    mClient->addActivity(activityId, privateData, publicData);
    mClient->updateActivity(activityId, privateData, publicData);
    mClient->removeActivity(activityId);
    mClient->activities();
    mClient->activityData(activityId);

    delete mClient;
}
