/*
* Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This component and the accompanying materials are made available
* under the terms of "Eclipse Public License v1.0"
* which accompanies this distribution, and is available
* at the URL "http://www.eclipse.org/legal/epl-v10.html".
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/

#include <QObject>
#include <QSharedPointer>

#include "afstorageproxy.h"
class AfManager;

class TestActivityManager : public QObject
{
    Q_OBJECT

private slots:
    void init();
    void cleanup();

    void testActivityList();
    void testLaunchStartupCaseWithoutUri();
    void testLaunchRunningCaseWithoutUri();
    void testLaunchStartupCaseUsingUris();
    void testLaunchRunningCaseUsingUris();
    void testLaunchRequestsWithInvalidUris();
    void testStartApplicationWithoutActivity();
    void testSwitchApplicationToForegroundWithoutActivity();
    void testGetThumbnail();
    void testUriWithTestRangeUid();

private:
    QSharedPointer<AfStorageProxy> mServiceProvider;
    AfManager *mManager;

};
