#ifndef HBACTIVITYPLUGINFAKE_H
#define HBACTIVITYPLUGINFAKE_H

#include "hbactivityplugininterface_p.h"

class HbActivityPluginFake : public HbActivityPluginInterface
{
    Q_OBJECT
    Q_INTERFACES(HbActivityPluginInterface)
    
public:
    virtual bool addActivity(const QString &activityId, const QVariant &data, const QVariantHash &parameters);
    virtual bool removeActivity(const QString &activityId);
    virtual bool updateActivity(const QString &activityId, const QVariant &data, const QVariantHash &parameters);
    virtual QList<QVariantHash> activities();
    virtual QVariant activityData(const QString &activityId);
    virtual bool waitActivity();
    virtual QVariantHash parseCommandLine(const QStringList &commandLineParams);
    
private:
    QHash<QString, QPair<QVariantHash, QVariant> > mActivities;
    
};

#endif // HBACTIVITYPLUGINFAKE_H
