/*
* Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This component and the accompanying materials are made available
* under the terms of "Eclipse Public License v1.0"
* which accompanies this distribution, and is available
* at the URL "http://www.eclipse.org/legal/epl-v10.html".
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/
#ifndef ACTIVITYDEBUGER_H
#define ACTIVITYDEBUGER_H

#include <QWidget>
#include <HbView>

class HbLabel;
class QString;
class ActivityClient;
class QPixmap;
class QByteArray;
class QVariant;
class HbComboBox;
class QGraphicsGridLayout;
class HbPushButton;
class QByteArray;
class ActivityDebugerConsole;

class ActivityDebuger: public HbView
{

    Q_OBJECT

public:
    ActivityDebuger(QGraphicsItem *parent = 0);
    ~ActivityDebuger();

private slots:
    void saveActivity();
    void deleteActivity();
    void getActivity();
    void getActivityData();
    void updateActivity();
    void getActivityThumb();
    
    void thumbnailReady(QPixmap pix, void * ptr);

private:
    void Before();
    void After();
    void Result();
    
    void UpdateConsole();


private:

    HbLabel *mTimesLabel;
    HbLabel *mPixmapLabel;
    HbLabel *mBytesLabel;
    HbLabel *mSizeLabel;
    QString mItemMeaage;
    QObject *mActivityClient;
    QObject *mActivityManager;
    QPixmap *mPixmap;
    QPixmap *mPixmap2;
    QPixmap *mEmptyPixmap;
    HbComboBox *mTimesCombo;
    HbComboBox *mLengthCombo;
    HbComboBox *mPixmapCombo;
    HbComboBox *mWidthCombo;
    HbComboBox *mHeightCombo;
    QGraphicsGridLayout *mLayout;
    HbPushButton *mSaveButton;
    HbPushButton *mDelButton;
    HbPushButton *mDelMyButton;
    HbPushButton *mGetButton;
    HbPushButton *mGetDataButton;
    HbPushButton *mUpdateButton;
    HbPushButton *mThumbButton;
    HbPushButton *mClearButton;
    QByteArray *mByteArray;
    TInt64 iBefore;
    TInt64 iAfter;
    TInt64 iResult;
    
    int mThumbwait;
    int mThumbnull;
    int mThumbcurrent;

    ActivityDebugerConsole* mConsole;

};

#endif //ACTIVITYDEBUGER_H
