/*
* Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This component and the accompanying materials are made available
* under the terms of "Eclipse Public License v1.0"
* which accompanies this distribution, and is available
* at the URL "http://www.eclipse.org/legal/epl-v10.html".
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/

#include <HbApplication>
#include <HbMainWindow>
#include <QSignalMapper>

#include "iconsview.h"

int main(int argc, char *argv[])
{
    HbApplication app(argc, argv);

    IconsView *view = new IconsView();

    QSignalMapper lastUseMapper;
    lastUseMapper.setMapping(&app, "Autosave");
    QObject::connect(&app, SIGNAL(aboutToQuit()), &lastUseMapper, SLOT(map()));
    QObject::connect(&lastUseMapper, SIGNAL(mapped(QString)), view, SLOT(saveActivity(QString)));

    HbMainWindow window;
    window.addView(view);
    window.show();

    if (app.activateReason() == Hb::ActivationReasonActivity) {
        // start-up case
        QVariant data = app.activateData();
        view->loadActivity(data);

    }

    return app.exec();
}
