/*
* Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This component and the accompanying materials are made available
* under the terms of "Eclipse Public License v1.0"
* which accompanies this distribution, and is available
* at the URL "http://www.eclipse.org/legal/epl-v10.html".
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/
#ifndef LUNCWIDGET_H_
#define LUNCWIDGET_H_

#include <hbwidget.h>
#include <QGraphicsLinearLayout>
#include <QGraphicsGridLayout>
#include <HbPushButton>
#include <hblabel.h>
#include <APGCLI.H> 
#include <W32STD.H>

class HbCheckBox;
class HbComboBox;
class CAfActivityLauncher;

class lunchwidget: public HbWidget
{
    Q_OBJECT
public:
    lunchwidget(QGraphicsItem *parent = 0);
    ~lunchwidget();

private:

    QGraphicsGridLayout *mGridLayout;
    HbPushButton *mLunchButton;
    HbPushButton *mLunchButton1;
    HbLabel* mResultLabel;
    QObject *mActivityManager;
    HbCheckBox* mBackgroundCheckBox;
    HbComboBox *mPlatformCombo;
    
    RApaLsSession mApaLsSession;
    RWsSession mWsSession;
    CAfActivityLauncher* mSymbianAL;

private slots:
    void lunchApp();
    void lunchAct();
    
private:
    void lunch(const QUrl& url);
};

#endif /* LUNCWIDGET_H_*/
