/*
* Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This component and the accompanying materials are made available
* under the terms of "Eclipse Public License v1.0"
* which accompanies this distribution, and is available
* at the URL "http://www.eclipse.org/legal/epl-v10.html".
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/
#include "underlinewidget.h"
#include <QRect>
#include <QPainter>
#include <QPainterPath>
#include <QPolygon>


underlinewidget::underlinewidget(QGraphicsItem *parent)
    : letterwidget(parent)
{
    mGridLayout->addItem(mItalic, 1, 0, 1, 1);
    mGridLayout->addItem(mBold, 1, 1, 1, 1);
 
    mColor = "blue";
    mNameCombo->addItem("Underline");
    
    delete mUnderline;
    mUnderline = NULL;
}

underlinewidget::~underlinewidget()
{

}

void underlinewidget::paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget)
{
    letterwidget::paint(painter, option, widget);
    QFont font;
    font.setPointSize(40);
    font.setUnderline(true);
    painter->setFont(font);
    painter->drawText(10, 120, "Under");
    painter->drawText(10, 240, "line");
}
