/*
* Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This component and the accompanying materials are made available
* under the terms of "Eclipse Public License v1.0"
* which accompanies this distribution, and is available
* at the URL "http://www.eclipse.org/legal/epl-v10.html".
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/
#ifndef VIEWMANAGER_H_
#define VIEWMANAGER_H_

#include <hbmainwindow.h>
#include <hbview.h>
#include <QVariant>
#include <afactivities_global.h>

class HbApplication;
class letterwidget;

class viewmanager : public HbMainWindow
{
    Q_OBJECT
public:
    viewmanager(HbApplication *hbapp);
    virtual ~viewmanager();
    void initialize();

private:
    letterwidget *mBoldWidget; 
    letterwidget *mItalicWidget; 
    letterwidget *mUnderlineWidget;
    HbView *mBoldView;
    HbView *mItalicView;
    HbView *mUnderlineView;

private slots:
    void toitalic();
    void tobold();
    void tounderline();

    void save();
    void del();
    void newStatus(bool status);

public slots:
    void loadActivityData(Af::ActivationReason reason, const QString &name, QVariantHash parameter);
    
signals:
    void statusChanged(bool status);

public:
    void loadActivityData(const QVariant &data, bool background, bool startup);
    letterwidget* currentWidget();

private:
    QObject *mActivityStorage;
    QObject *mActivaction;
    QString mStatename;
    QVariant mSaveVariant;
    HbApplication *mHbApp;
};

#endif /* VIEWMANAGER_H_ */
