/*
* Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This component and the accompanying materials are made available
* under the terms of "Eclipse Public License v1.0"
* which accompanies this distribution, and is available
* at the URL "http://www.eclipse.org/legal/epl-v10.html".
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/
#include <qservicemanager.h>
#include <HbInstance>
#include <QEventLoop>
#include <QStringList>
#include <QCoreApplication>
#include <hbapplication.h>
#include "viewmanager.h"
#include "basewidget.h"

#include "afstorageglobals.h"
#include <QFile>
#include <QTextStream>

QTM_USE_NAMESPACE

viewmanager::viewmanager():
    HbMainWindow()
{
    QServiceManager serviceManager;
    mActivityStorage = serviceManager.loadInterface("com.nokia.qt.activities.Storage");
    if (!mActivityStorage) {
        qFatal("load Storage plugin failed");
    }

    mActivityManager = serviceManager.loadInterface("com.nokia.qt.activities.ActivityManager");
    if (!mActivityManager) {
        qFatal("load Manger plugin failed");
    }    
    
    mFile = new QFile("c:\\data\\nftlowmemory.txt");    
    mFile->open(QIODevice::Append | QIODevice::Text);
    mStream = new QTextStream(mFile);    
    mBaseWidget = new basewidget(mActivityStorage, mActivityManager, mStream);
    mBaseView = addView(mBaseWidget);
    mBaseView->setTitle("Low memory");    
    setCurrentView(mBaseView);
        
}

viewmanager::~viewmanager()
{
    delete mActivityStorage;
    delete mActivityManager;
    delete mFile;
    delete mStream;
}
