# Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
# All rights reserved.
# This component and the accompanying materials are made available
# under the terms of "Eclipse Public License v1.0"
# which accompanies this distribution, and is available
# at the URL "http://www.eclipse.org/legal/epl-v10.html".
# Initial Contributors:
# Nokia Corporation - initial contribution.
# Contributors:
# Description:


TEMPLATE = app

include(../../../../../common.pri)
include(../../../../tsrc/testutils/testutils.pri)

CONFIG(debug, debug|release) {
    DESTDIR = debug
} else {
    DESTDIR = release
}
CONFIG += HB
CONFIG += debug_and_release \
    console
QT += testlib

DEFINES += CONTENT_ARSENAL_STORAGE_UT
coverage:DEFINES += COVERAGE_MEASUREMENT

DEPENDPATH += . \
    ./inc \
    ./src

INCLUDEPATH += . \
    ./inc \
    ../../inc \
    ../../../../inc \
    ../../../homescreensrv_plat/contentstorage_api \
    ../../../../srvinc \
    ../../../../cautils/inc \
    ../../../casrvmgr/inc   \
    ../../../../castorage/inc \
    $$MW_LAYER_SYSTEMINCLUDE
    
include(t_caappscanner.pri)
symbian: { 
    ### get rid of localization warnings
    CONFIG -= hb
    load(hb.prf)
    CONFIG -= symbian_i18n
    ###
    
    CONFIG += symbian_test
    coverage: CONFIG -= symbian_test

    TARGET.UID2 = 0x10009D8D
    TARGET.UID3 = 0x2002870E
    TARGET.CAPABILITY = ALL \
        -TCB
    TARGET.EPOCSTACKSIZE = 0x14000 \
        // \
        80kB
    TARGET.EPOCHEAPSIZE = 0x20000 \
        0x1000000 \
        // \
        128kB \
        - \
        16MB
        LIBS += \
        -lapparc \
        -lapgrfx \
        -lefsrv \
        -leuser \
        -lPlatformEnv \
        -lbafl \
        -lcamenu \
        -lcasathandler \
        -lcalocalizerscanner \
        -lcommdb \
        -lefsrv \
        -lestor \
        -lapparc \
        -lplatformenv \
        -lsysutil \
        -lapgrfx \
        -lws32 \
        -lavkon \
        -lcone \
        -lecom \
        -lsisregistryclient \
        -lWidgetRegistryClient \
        -lsqldb \
        -lcomsdbgutil \
        -lscrclient \
        -lsifnotification

        exportDB.sources = ./data/castorage.db
        exportDB.path = c:/testing/data/t_caappscanner/

        exportWRT.sources = ./data/*.wgt
        exportWRT.path = c:/testing/data/t_caappscanner/installs/
        
        exportMMCHistory.sources = ./data/mmchistory 
        exportMMCHistory.path = c:/testing/data/t_caappscanner/
        
        exportARMSis.sources = ./data/armv5/sapiapp_S60_3_X_v_1_0_0.sisx
        exportARMSis.path = c:/testing/data/t_caappscanner/installs/
        
        exportWINSCWSis.sources = ./data/winscw/sapiapp_S60_3_X_v_1_0_0.sisx
        exportWINSCWSis.path = c:/testing/data/t_caappscanner/installs/
        
        exportJava.sources = ./data/*.jar
        exportJava.path = c:/testing/data/t_caappscanner/        
        
        BLD_INF_RULES.prj_exports += "./data/mmchistory c:/testing/data/t_caappscanner/"
        BLD_INF_RULES.prj_exports += "./data/castorage.db c:/testing/data/t_caappscanner/"
        BLD_INF_RULES.prj_exports += "./data/AccuWeather_W3C.wgt c:/testing/data/t_caappscanner/installs/"      
        BLD_INF_RULES.prj_exports += "./data/SmokeTestUnsigned.wgt c:/testing/data/t_caappscanner/installs/"           
        BLD_INF_RULES.prj_exports += "./data/winscw/sapiapp_S60_3_X_v_1_0_0.sisx c:/testing/data/t_caappscanner/installs/"
        BLD_INF_RULES.prj_exports += "./data/HelloWorld.jar c:/testing/data/t_caappscanner/"
        
        DEPLOYMENT += exportDB exportWRT exportMMCHistory exportARMSis exportJava
        
        BLD_INF_RULES.prj_testexports += "$${exportDB.sources} $${exportDB.path}$$basename(exportDB.sources)"
        BLD_INF_RULES.prj_testexports += "./data/AccuWeather_W3C.wgt c:/testing/data/t_caappscanner/installs/"      
        BLD_INF_RULES.prj_testexports += "./data/SmokeTestUnsigned.wgt c:/testing/data/t_caappscanner/installs/" 
        BLD_INF_RULES.prj_testexports += "$${exportMMCHistory.sources} $${exportMMCHistory.path}$$basename(exportMMCHistory.sources)"
        BLD_INF_RULES.prj_testexports += "$${exportWINSCWSis.sources} $${exportWINSCWSis.path}$$basename(exportWINSCWSis.sources)"
        BLD_INF_RULES.prj_testexports += "./data/HelloWorld.jar c:/testing/data/t_caappscanner/" 
}


