# Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
# All rights reserved.
# This component and the accompanying materials are made available
# under the terms of "Eclipse Public License v1.0"
# which accompanies this distribution, and is available
# at the URL "http://www.eclipse.org/legal/epl-v10.html".
# Initial Contributors:
# Nokia Corporation - initial contribution.
# Contributors:
# Description:


TEMPLATE = app

include(../../../../../common.pri)

CONFIG(debug, debug|release) {
    DESTDIR = debug
} else {
    DESTDIR = release
}
CONFIG += HB
CONFIG += debug_and_release \
    console
QT += testlib
    
DEFINES += CONTENT_ARSENAL_STORAGE_UT
coverage:DEFINES += COVERAGE_MEASUREMENT

DEPENDPATH += . \
    ./inc \
    ./src
    
INCLUDEPATH += . \
    ./inc \
    ../../inc \
    ../../../../inc \
    ../../../homescreensrv_plat/contentstorage_api \
    ../../../../srvinc \
    ../../../../cautils/inc \
    ../../../casrvmgr/inc   \
    ../../../../castorage/inc \
    ../../../../srvinc  \
    $$MW_LAYER_SYSTEMINCLUDE
    
include(t_calocalizerscanner.pri)
    
        
symbian: { 
    ### get rid of localization warnings
    CONFIG -= hb
    load(hb.prf)
    CONFIG -= symbian_i18n
    ###
coverage: {
    SUBDIRS  += ../../    
}    
    CONFIG += symbian_test hb
    coverage: CONFIG -= symbian_test

    TARGET.UID2 = 0x100039CE
    TARGET.UID3 = 0x2002870C
    TARGET.CAPABILITY = ALL \
        -TCB
    TARGET.EPOCSTACKSIZE = 0x14000 \
        // \
        80kB
    TARGET.EPOCHEAPSIZE = 0x20000 \
        0x1000000 \
        // \
        128kB \
        - \
        16MB
        
    SOURCES += ../../src/*.cpp
    
    SOURCES += ../../../../srvsrc/castorageproxy.cpp
    SOURCES += ../../../../srvsrc/casrvengutils.cpp
    SOURCES += ../../../../srvsrc/casrv.cpp
    SOURCES += ../../../../srvsrc/casrvsession.cpp
    SOURCES += ../../../../srvsrc/casrvnotifier.cpp
    SOURCES += ../../../../srvsrc/cabackupnotifier.cpp

    SOURCES += ../../../../castorage/src/*.cpp
    
    
    LIBS += -leuser \
        -lecom \
        -lcautils \
        -lcamenu  \
        -lsqldb   \
        -lefsrv   \
        -lbafl    \
        -lflogger \
        -lestor   \
        -lapgrfx  \
        -lapparc  \
        -lcasrvmanager \
        -lsysutil \
        -lscrclient \
        -lxqutils \
        -lsifnotification  
        
        
        exports1.sources += ./data/castorage.db
        exports1.path = c:/testing/data/localizer
        
        DEPLOYMENT += exports1
        
        BLD_INF_RULES.prj_testexports += "./data/castorage.db c:/testing/data/localizer/"
        
}


        

