/*
* Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This component and the accompanying materials are made available
* under the terms of "Eclipse Public License v1.0"
* which accompanies this distribution, and is available
* at the URL "http://www.eclipse.org/legal/epl-v10.html".
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description: 
*
*/
#ifndef CA_SAT_MONITOR_TEST_UTILS_H
#define CA_SAT_MONITOR_TEST_UTILS_H

#include "f32file.h"
#include "casrvplugin.h"


class CCaStorageProxy;
class CCaInnerEntry;

class CTestUtils: public CBase
{
public:

    /**/
    virtual ~CTestUtils();

    /**/
    static CTestUtils* NewL();

    /**/
    static CTestUtils* NewLC();

    /**/
    TUint FingAppUidL( const TDesC& aName, CCaStorageProxy* aStorage );

    /**/
    void WaitL(TInt aMicroSec);

    /**
     * Gets RProperty
     */
    TInt GetRProperty( TUid aCategory, TUint aKey, TDes& aValue );

    /**
     * Gets RProperty
     */
    TInt GetRProperty( TUid aCategory, TUint aKey, TInt& aValue );

    /**
     * Sets RProperty
     */
    TInt SetRProperty( TUid aCategory, TUint aKey, const TDesC& aValue );

    /**
     * Sets RProperty
     */
    TInt SetRProperty( TUid aCategory, TUint aKey, TInt aValue );
    
    /**
     * Sets RProperty
     */
    TInt DefineIntRProperty( TUid aCategory, TUint aKey );
    
    /**
     * Sets RProperty
     */
    TInt DefineTextRProperty( TUid aCategory, TUint aKey );

    /**
     * Copys test Db
     */
    TInt CopyDb();

    /**
     * Checks if app exists in Db
     */
    TBool AppExistsInStorageL( TInt aUid, CCaStorageProxy* aStorage);

    CCaInnerEntry* GetAppEntryL( TInt aUid, CCaStorageProxy* aStorage);

    TInt AppsWithFlagsOffL( TInt aFlags, CCaStorageProxy* aStorage);

    TInt GetAppFlagsL( TInt aUid, CCaStorageProxy* aStorage);

    void RemoveAppL( TInt aUid, CCaStorageProxy* aStorage);

    CCaSrvPlugin* LoadPluginL( TUid aImplUid, TPluginParams aPluginParams );

private:

    /**
     * Copys files
     */
    TInt Copy( const TDesC& aSource, const TDesC& aDest );

    CTestUtils();

    void ConstructL();

    RFs iFs;
    CFileMan* iFileManager;

    /**
     * Local Active Sheduler.
     * Own.
     */
    CActiveSchedulerWait* iActiveWait;

};

#endif
