/*
 * Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
 * All rights reserved.
 * This component and the accompanying materials are made available
 * under the terms of "Eclipse Public License v1.0"
 * which accompanies this distribution, and is available
 * at the URL "http://www.eclipse.org/legal/epl-v10.html".
 *
 * Initial Contributors:
 * Nokia Corporation - initial contribution.
 *
 * Contributors:
 *
 * Description:
 *
 */

#ifndef __T_caUsifScanner_H__
#define __T_caUsifScanner_H__

#include <QtTest/QtTest>

#include "casrvplugin.h"
#include "casrvmanager.h"

//  FORWARD DECLARATIONS
class CTestUtils;
class CCaStorageProxy;
class CCaSrvEngUtils;
class T_CaInstaller;

namespace Usif{
    class RSoftwareComponentRegistry; 
}

#include <e32def.h>

class T_caUsifScaner : public QObject
{
    Q_OBJECT
public:

    T_caUsifScaner();

private slots:

    void initTestCase();
    void init();

    void testNew();
    void testLoadPlugin();
    void testInstalled();
    void testAddNewApp();
    void testAddRemovable();
    void testInstallNotifier();

    void testJavaStrategy();
    void testSwiStrategy();
    void testUsifStrategy();


    void cleanup();
    void cleanupTestCase();



private:    // Data
    //setup methods

    void Setup_AddNewAppL();
    void Setup_AddRemovableL();

    CTestUtils *iTestUtils;

    CCaStorageProxy *iStorage;

    CCaSrvEngUtils *iSrvEngUtils;

    TPluginParams iPluginParams;
    
    T_CaInstaller *iInstaller;
    
    Usif::RSoftwareComponentRegistry *iScr;
};

#endif      //  __T_caUsifScanner_H__

// End of file
