# Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
# All rights reserved.
# This component and the accompanying materials are made available
# under the terms of "Eclipse Public License v1.0"
# which accompanies this distribution, and is available
# at the URL "http://www.eclipse.org/legal/epl-v10.html".
# Initial Contributors:
# Nokia Corporation - initial contribution.
# Contributors:
# Description:


TEMPLATE = app

include(../../../../../common.pri)
include(../../../../tsrc/testutils/testutils.pri)

CONFIG(debug, debug|release) {
    DESTDIR = debug
} else {
    DESTDIR = release
}
CONFIG += HB
CONFIG += debug_and_release \
    console
QT += testlib

DEFINES += CONTENT_ARSENAL_STORAGE_UT
coverage:DEFINES += COVERAGE_MEASUREMENT

DEPENDPATH += . \
              ./inc \
              ./src

INCLUDEPATH += . \
    ./inc \
    ../../inc \
    ../../../../inc \
    ../../../homescreensrv_plat/contentstorage_api \
    ../../../../srvinc \
    ../../../../cautils/inc \
    ../../../../castorage/inc \
    ../../../casrvmgr/inc \
    $$MW_LAYER_SYSTEMINCLUDE

include(t_causifscanner.pri)

symbian: { 
    ### get rid of localization warnings
    CONFIG -= hb
    load(hb.prf)
    CONFIG -= symbian_i18n
    ###
    CONFIG += symbian_test
    coverage: CONFIG -= symbian_test

    TARGET.UID2 = 0x10009D8D
    TARGET.UID3 = 0x2002DCF2
    TARGET.CAPABILITY = ALL \
        -TCB
    TARGET.EPOCSTACKSIZE = 0x14000 \
        // \
        80kB
    TARGET.EPOCHEAPSIZE = 0x20000 \
        0x1000000 \
        // \
        128kB \
        - \
        16MB

    LIBS += \
        -lapparc \
        -lapgrfx \
        -lefsrv \
        -leuser \
        -lPlatformEnv \
        -lbafl \
        -lcamenu \
        -lcasathandler \
        -lcalocalizerscanner \
        -lcommdb \
        -lefsrv \
        -lestor \
        -lapparc \
        -lplatformenv \
        -lsysutil \
        -lswinstcli \
        -lapgrfx \
        -lws32 \
        -lavkon \
        -lcone \
        -lecom \
        -lsisregistryclient \
        -lsqldb \
        -lcomsdbgutil \
        -lsif \
        -lscrclient \
        -lsifnotification
        

        exportDB.sources = ./data/castorage.db
        exportDB.path = c:/testing/data/t_causifscanner/

        exportARMSis.sources = ./data/armv5/sapiapp_S60_3_X_v_1_0_0.sisx
        exportARMSis.path = c:/testing/data/t_causifscanner/installs/

        exportWINSCWSis.sources = ./data/winscw/sapiapp_S60_3_X_v_1_0_0.sisx
        exportWINSCWSis.path = c:/testing/data/t_causifscanner/installs/
            
        DEPLOYMENT += exportARMSis \
                      exportDB
        
        BLD_INF_RULES.prj_testexports += "$${exportDB.sources} $${exportDB.path}$$basename(exportDB.sources)"
        BLD_INF_RULES.prj_testexports += "$${exportWINSCWSis.sources} $${exportWINSCWSis.path}$$basename(exportWINSCWSis.sources)"
        BLD_INF_RULES.prj_exports += "$${exportDB.sources} $${exportDB.path}$$basename(exportDB.sources)"
        BLD_INF_RULES.prj_exports += "$${exportWINSCWSis.sources} $${exportWINSCWSis.path}$$basename(exportWINSCWSis.sources)"
}
