/*
* Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This component and the accompanying materials are made available
* under the terms of "Eclipse Public License v1.0"
* which accompanies this distribution, and is available
* at the URL "http://www.eclipse.org/legal/epl-v10.html".
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description: 
*
*/
#ifndef CA_WIDGET_SCANNER_TEST_UTILS_H
#define CA_WIDGET_SCANNER_TEST_UTILS_H
//utility class for tests
//all utility methods should be implemented here

//#include "casrvengutils.h"
#include "f32file.h"
#include "casrvplugin.h"


class CCaStorageProxy;
class CCaInnerEntry;
class CCaWidgetDescription;

class CTestUtils: public CBase
{
public:

    /**/
    virtual ~CTestUtils();

    /**/
    static CTestUtils* NewL();

    /**/
    static CTestUtils* NewLC();

    TUint FindAppUidL( const TDesC& aName, CCaStorageProxy* aStorage );

    /**/
    /**/
    TInt SimpleCloseTaskL(TInt aUid);
    void WaitL(TInt aMicroSec);
    /**/
    void InstallFinishedL();

    /**
     * Copys test Db
     */
    TInt CopyDb();

    /**
     * Checks if app exists in Db
     */
    TInt WidgetsCountL( CCaStorageProxy* aStorage );
    
    TBool WidgetExistsInStorageL( const TDesC& aName, const TDesC& aValue, CCaStorageProxy* aStorage);

    CCaInnerEntry* GetAppEntryL( TInt aUid, CCaStorageProxy* aStorage);

    CCaWidgetDescription* GetWidgetEntryL( const TDesC& aText, CCaStorageProxy* aStorage);
    
    TInt GetWidgetFlagsL(const TDesC& aText, CCaStorageProxy* aStorage);
    
    TInt AppsWithFlagsOffL( TInt aFlags, CCaStorageProxy* aStorage);

    TInt GetAppFlagsL( TInt aUid, CCaStorageProxy* aStorage);

    void RemoveAppL( TInt aUid, CCaStorageProxy* aStorage);

    CCaSrvPlugin* LoadPluginL( TUid aImplUid, TPluginParams* aPluginParams );

    /**
     * Copys files
     */
    TInt Copy( const TDesC& aSource, const TDesC& aDest );

    TInt RemoveL( const TDesC& aFile );

private:

    
    CTestUtils();

    void ConstructL();

    RFs iFs;
    CFileMan* iFileManager;

    /**
     * Local Active Sheduler.
     * Own.
     */
    CActiveSchedulerWait* iActiveWait;

};

#endif
