/*
* Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This component and the accompanying materials are made available
* under the terms of "Eclipse Public License v1.0"
* which accompanies this distribution, and is available
* at the URL "http://www.eclipse.org/legal/epl-v10.html".
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description: 
*
*/
/*
 * T_cahswidgetscanner.h
 *
 *  Created on: 2009-09-16
 *      Author:
 */

#ifndef T_CAWIDGETSCANNER_H
#define T_CAWIDGETSCANNER_H

class CTestUtils;
class CCaStorageProxy;
class CCaSrvManager;
class CCaSrvEngUtils;
class T_CaInstaller;
class CCaSrvPlugin;

#include <QtTest/QtTest>

#include <e32def.h>
#include <f32file.h>



namespace Usif{
    class RSoftwareComponentRegistry; 
}


class T_CaWidgetScanner: public QObject
    {
    Q_OBJECT

private:

    void WaitL(TInt aMicroSec);
    TInt AppendMmcIdL(const TDesC& aText);
    TBool MmcAttributeSetL(TInt aId);
    void createImportDirectoryL();
    
    void testUpdateWidgetTrapped();
    void testUpdateTheSameWidgetTrapped();
    void testUpdateMmcRemoveInsertTrapped();
    
private slots:

    void initTestCase();
    void cleanupTestCase();
    void init();
    void cleanup();


    //tests for widget scanner

    void testPluginNewL();
    void testRemoveMmcWidget();
    void testUpdateMmcRemoveInsert();  
    void testAddWidget();
    void testUpdateWidget();
    void testUpdateTheSameWidget();       
    void testRemoveWidget();
    void testSetMissingFlag();  
    void testSetLocalizationsL();
    void testUtils();
    void testParsePreviewImageName();
    void testParseIconName();
    void testCloneWidgetDescriptionL();
    

private:

    CTestUtils* iTestUtils;
    
    CCaSrvEngUtils* iSrvEngUtils;
    
    Usif::RSoftwareComponentRegistry *iScr;

    CCaStorageProxy* iStorage;

    RFs iFs;
    
    RBuf iImportPath;
    RBuf iWidgetScanFolder;
    RBuf iWidgetScanFile1;
    
    CCaSrvPlugin* iPlugin;
    
    
    CCaSrvManager* iSrvManager;
    
    T_CaInstaller *iInstaller;
    };

#endif // T_CAWIDGETSCANNER_H 
