# Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
# All rights reserved.
# This component and the accompanying materials are made available
# under the terms of "Eclipse Public License v1.0"
# which accompanies this distribution, and is available
# at the URL "http://www.eclipse.org/legal/epl-v10.html".
# Initial Contributors:
# Nokia Corporation - initial contribution.
# Contributors:
# Description:


TEMPLATE = app

include(../../../../../common.pri)
include(../../../../tsrc/testutils/testutils.pri)

CONFIG(debug, debug|release) {
    DESTDIR = debug
} else {
    DESTDIR = release
}
CONFIG += HB
CONFIG += debug_and_release \
    console
QT += testlib
    
DEFINES += CONTENT_ARSENAL_STORAGE_UT
coverage:DEFINES += COVERAGE_MEASUREMENT

DEPENDPATH += . \
    ./inc \
    ./src
    
INCLUDEPATH += . \
    ./inc \
    ../../inc \
    ../../../../inc \
    ../../../homescreensrv_plat/contentstorage_api \
    ../../../../srvinc \
    ../../../../extinc \
    ../../../../cautils/inc \
    ../../../casrvmgr/inc   \
    ../../../../castorage/inc \
    ../../../../srvinc  \
    /epoc32/include/mw/hb/hbcore \
    $$MW_LAYER_SYSTEMINCLUDE

include(t_cawidgetscanner.pri)

symbian: { 

    ### get rid of localization warnings
    CONFIG -= hb
    load(hb.prf)
    CONFIG -= symbian_i18n
    ###

    CONFIG += symbian_test
    coverage: CONFIG -= symbian_test

    TARGET.UID2 = 0x10009D8D
    TARGET.UID3 = 0x20028705
    TARGET.CAPABILITY = ALL \
        -TCB
    TARGET.EPOCSTACKSIZE = 0x14000 \
        // \
        80kB
    TARGET.EPOCHEAPSIZE = 0x20000 \
        0x1000000 \
        // \
        128kB \
        - \
        16MB
    
    LIBS += \
        -leuser \
        -lestor \
        -lapparc \
        -lapgrfx \
        -lcautils \
        -lsysutil \
        -lplatformenv \
        -lcasrvmanager \
        -lws32 \
        -lecom \
        -lxmlengineDOM \
        -lcharconv \
        -lplatformenv \
        -lsisregistryclient \
        -lsqldb \
        -lbafl \
        -lefsrv \
        -lflogger \
        -lcamenu \
        -lscrclient \
        -lsifnotification \
        -lsif \
        -lhbcore \
        -lxmlengineDOM \
        -lxqutils

        exportDB.sources = ./data/castorage.db ./data/widgettranslation_en_GB.qm
        exportDB.path = c:/testing/data/t_cawidgetscanner/

        exportManifest.sources = ./data/validwidget1.manifest ./data/validwidget2.manifest ./data/validwidget3.manifest ./data/validwidget4.manifest
        exportManifest.path = c:/testing/data/t_cawidgetscanner

        exportSis.path = c:/testing/data/installs
        exportSis.sources = ./data/validwidget1.SISX ./data/validwidget2.SISX ./data/validwidget3.SISX ./data/validwidget4.SISX

        BLD_INF_RULES.prj_testexports += "$${exportDB.sources} $${exportDB.path}"

        for(exportManifest, exportManifest.sources):{
            BLD_INF_RULES.prj_testexports += \
            "./$$exportManifest $$exportManifest.path/$$basename(exportManifest)"
        }
            
        for(exportSis, exportSis.sources): {
            BLD_INF_RULES.prj_testexports += \
                "./$$exportSis $$exportSis.path/$$basename(exportSis)"
        }

        DEPLOYMENT += exportDB exportManifest exportSis
}


        

