/*
 * Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
 * All rights reserved.
 * This component and the accompanying materials are made available
 * under the terms of "Eclipse Public License v1.0"
 * which accompanies this distribution, and is available
 * at the URL "http://www.eclipse.org/legal/epl-v10.html".
 *
 * Initial Contributors:
 * Nokia Corporation - initial contribution.
 *
 * Contributors:
 *
 * Description:
 *
 */

#ifndef CASTORAGETESTSQLCOMMANDS_H_
#define CASTORAGETESTSQLCOMMANDS_H_

_LIT(KSQLGetEntryTimestamp, "SELECT EN_CREATION_TIME AS Data FROM CA_ENTRY where ENTRY_ID = :ENTRY_ID0 ");

// add tests
_LIT(KTestName, "AddTest");
_LIT(KTestName1, "TestName1");
_LIT(KTestName2, "TestName2");
_LIT(KTestNameUpdate, "AddTestUpdate");
_LIT(KTypeName, "Folder");
_LIT(KTypeName2, "application");
const TUint flag = 4;
const TUint flagUpdate = 8;

_LIT(KAttrName_1, "Attribute_Name_1");
_LIT(KAttrName_2, "Attribute_Name_2");
_LIT(KAttrName_3, "Attribute_Name_3");
_LIT(KAttrValue_1, "Attribute_Value_1");
_LIT(KAttrValue_2, "Attribute_Value_2");
_LIT(KAttrValue_3, "Attribute_Value_3");

_LIT(KSQLCheckAttribute, "SELECT * FROM CA_ATTRIBUTE \
WHERE AT_ENTRY_ID = :ENTRY_ID");

_LIT(KSQLGetAttribute, "SELECT * FROM CA_ATTRIBUTE WHERE AT_ENTRY_ID = :AT_ENTRY_ID");

// remove tests
_LIT(KSQLGetIdCountFromEntryTable,"SELECT COUNT(*) AS Data FROM CA_ENTRY");
_LIT(KSQLGetIdCountFromIconTable,"SELECT COUNT(*) AS Data FROM CA_ICON");

// touch
_LIT(KSQLGetIdCountFromLaunchTable,"SELECT COUNT(*) AS Data FROM CA_LAUNCH");
_LIT(KSQLGetUsedFlagCountFromEntryTable, "SELECT COUNT(*) AS Data FROM CA_ENTRY \
WHERE EN_FLAGS & :EN_FLAGS = :EN_FLAGS");

const TInt KErrNoData = 1001;
const TInt KErrWrongData = 1002;
const TInt KErrBadParams = 1003;

const TInt KAllCollectionsGroupId = 2;
const TInt KMaxFlagsMask = 63;
const TInt KMaxFlagsMaskForCombinedTest = 15;
const TInt KCalendarAppUid = 268458241;
const TInt KTestAppUid = 268458111;
const TInt KTestAppUid2 = 268458112;

_LIT(KTypeNameApplication, "application");
_LIT(KTypeNameFolder, "folder");

//organize tests
_LIT(KSQLGetUnexistingIdFromGroup,"SELECT MAX(GE_ENTRY_ID) + 1 AS Data FROM CA_GROUP_ENTRY WHERE GE_GROUP_ID = :GE_GROUP_ID");

// GE_ENTRY_ID AS GE_GROUP_ID because we don't have proper execute
_LIT(KSQLGetEntryIdsFromGroupInPositionOrder, "SELECT GE_ENTRY_ID AS GE_GROUP_ID FROM CA_GROUP_ENTRY WHERE GE_GROUP_ID = :GE_GROUP_ID ORDER BY GE_POSITION");

//get entries tests
_LIT(KSQLGetEntriesCountFromSpecificGroup, "SELECT COUNT(*) AS Data FROM CA_GROUP_ENTRY \
WHERE GE_GROUP_ID = :GE_GROUP_ID");

_LIT(KSQLGetEntriesCountAsParentsForSpecificEntry, "SELECT COUNT(*) AS Data FROM CA_GROUP_ENTRY \
WHERE GE_ENTRY_ID = :GE_ENTRY_ID");

_LIT(KSQLGetIdEntryFromSpecificGroup, "SELECT GE_ENTRY_ID AS ENTRY_ID FROM CA_GROUP_ENTRY \
WHERE GE_GROUP_ID = :GE_GROUP_ID");
const TUint KFlagsOnTable[5] = { 0, 2, 5, 36, 60 };
const TUint KFlagsOffTable[5] = { 1, 2, 6, 18, 25 };
const TUint KFlagsOffTableMasks[5] = { 30, 29, 25, 13, 6 };

// localization
_LIT(KSQLCountFromLocalizationTable,"SELECT COUNT(*) AS Data FROM CA_LOCALIZATION_TEXT");


#endif /* CASTORAGETESTSQLCOMMANDS_H_ */
