# Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
# All rights reserved.
# This component and the accompanying materials are made available
# under the terms of "Eclipse Public License v1.0"
# which accompanies this distribution, and is available
# at the URL "http://www.eclipse.org/legal/epl-v10.html".
# Initial Contributors:
# Nokia Corporation - initial contribution.
# Contributors:
# Description:


TEMPLATE = app

include(../../../common.pri)

CONFIG(debug, debug|release) {
    DESTDIR = debug
} else {
    DESTDIR = release
}
CONFIG += HB
CONFIG += debug_and_release \
    console
QT += testlib
    
DEFINES += CONTENT_ARSENAL_STORAGE_UT
coverage:DEFINES += COVERAGE_MEASUREMENT

DEPENDPATH += . \
    ./inc \
    ./src
    
INCLUDEPATH += . \
    ./inc \
    ../../inc \
    ../../../homescreensrv_plat/contentstorage_api \
    ../../srvinc \
    ../../extinc \
    ../../cautils/inc \
    ../../casrv/casrvmgr/inc   \
    ../../castorage/inc \
    ../../../srvinc  \
    $$MW_LAYER_SYSTEMINCLUDE

include(t_casrv.pri)
        
symbian: { 
    ### get rid of localization warnings
    CONFIG -= hb
    load(hb.prf)
    CONFIG -= symbian_i18n
    ###
    CONFIG += symbian_test
    coverage: CONFIG -= symbian_test

    TARGET.UID2 = 0x10009D8D
    TARGET.UID3 = 0x2002870D
    TARGET.CAPABILITY = ALL \
        -TCB
    TARGET.EPOCSTACKSIZE = 0x14000 \
        // \
        80kB
    TARGET.EPOCHEAPSIZE = 0x20000 \
        0x1000000 \
        // \
        128kB \
        - \
        16MB
    
    LIBS += \
        -lcautils \
        -lcasathandler \
        -lefsrv \
        -lestor \
        -lapparc \
        -lCenRepNotifHandler \
        -lcentralrepository \
        -lplatformenv \
        -lsysutil \
        -leuser \
        -lapgrfx \
        -lws32 \
        -lbafl \
        -lavkon \
        -lcone \
        -lcasrvmanager \
        -lsisregistryclient \
        -lecom \
        -lsqldb \
        -lflogger \
        -lscrclient \
        -lsifnotification

        exportDB.sources = ./data/castorage.db
        exportDB.path = c:/testing/data/t_casrv/

        BLD_INF_RULES.prj_testexports += "$${exportDB.sources} $${exportDB.path}"

        DEPLOYMENT += exportDB
}


        

