/*
* Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This component and the accompanying materials are made available
* under the terms of "Eclipse Public License v1.0"
* which accompanies this distribution, and is available
* at the URL "http://www.eclipse.org/legal/epl-v10.html".
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description: 
*
*/
#ifndef TSTASKMONITOR_P_H
#define TSTASKMONITOR_P_H


#include <w32std.h>

#include <QList>
#include <QSharedPointer>
#include <QPair>

#include "tstaskmonitorobserver.h"
#include "tstasklauncher.h"
#include "tstaskmonitor.h"

class RDesReadStream;
class TsTask;
class TsTaskContent;
class CTsTaskMonitorClient;

class TsTaskMonitorPrivate : public MTsTaskMonitorObserver, public TsTaskLauncher
{
public:
    TsTaskMonitorPrivate(TsTaskMonitor *q);
    virtual ~TsTaskMonitorPrivate();
    
public:
    QList<TsTaskChange> changeList();

public: // from MTsTaskMonitorObserver
    virtual void HandleRunningAppChange();

public: // from TsTaskLauncher
    virtual void openTask(const QByteArray &key);
    virtual void closeTask(const QByteArray &key);
    
private: // helper methods
    void internalizeContentL(RDesReadStream &dataStream, QScopedPointer<TsTaskContent> &content);
    
private:    
    TsTaskMonitor *q_ptr;
    CTsTaskMonitorClient *mClient;
    RWsSession &mWsSession;
};

#endif //TSTASKMONITOR_P_H
