/*
* Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This component and the accompanying materials are made available
* under the terms of "Eclipse Public License v1.0"
* which accompanies this distribution, and is available
* at the URL "http://www.eclipse.org/legal/epl-v10.html".
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/
#ifndef T_TSTASKMONITORCLIENT_H
#define T_TSTASKMONITORCLIENT_H

#include <QObject>
#include <W32STD.H>
#include "tstaskmonitor.h"

/**
* @test Test class for TsTaskMonitorClient
*/
class T_TsTaskMonitorClient : public QObject
{
    Q_OBJECT

private slots:
    void initTestCase();
    void cleanupTestCase();
    
    void testTaskListChangeSignal();
    void testTaskList();
    void testTaskClose();
    
private slots:
    void testTaskChangeInfoGetters();
    void testCreatingInsertTaskChangeInfo();
    void testCreatingDeleteTaskChangeInfo();
    void testCreatingMoveTaskChangeInfo();
    void testCreatingUpdateTaskChangeInfo();
    void testCreatingCancelTaskChangeInfo();
    
private: // helper methods
    QSharedPointer<TsTask> findTask(const QString &taskName);
    
private:
    TsTaskMonitor mTaskMonitor;    
    RWsSession mWsSession;

};

#endif //T_TSTASKMONITORCLIENT_H
