/*
* Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This component and the accompanying materials are made available
* under the terms of "Eclipse Public License v1.0"
* which accompanies this distribution, and is available
* at the URL "http://www.eclipse.org/legal/epl-v10.html".
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/
#ifndef TSMODELITEM_H
#define TSMODELITEM_H

#include <e32base.h>


#include "tsmodelitemkey.h"

class MTsModel;

class TTsModelItem {
public:
    TTsModelItem(const MTsModel& model, TInt offset);
    TTsModelItem(const TTsModelItem& item);
    const TDesC& displayNameL() const;
    TInt iconHandleL() const;
    TTime timestampL() const;
    TTsModelItemKey keyL() const;
    TBool isActiveL() const;
    TBool isClosableL() const;
    TBool closeL() const;
    TBool launchL() const;
    
public:
    void ExternalizeL(RWriteStream& stream) const;
    
private:
    void validateL() const;

private:
    const MTsModel& mModel;
    const TInt mIndex;
};

#endif //TSMODELITEM_H
