/*
* Copyright (c) 2008 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This component and the accompanying materials are made available
* under the terms of "Eclipse Public License v1.0"
* which accompanies this distribution, and is available
* at the URL "http://www.eclipse.org/legal/epl-v10.html".
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Task list entry
*
*/
#include <s32mem.h>
#include "tsmodelitemkeymsg.h"

// -----------------------------------------------------------------------------
CTsModelItemKeyMsg* CTsModelItemKeyMsg::NewLC(RReadStream& stream)
{
    CTsModelItemKeyMsg* self = new (ELeave)CTsModelItemKeyMsg();
    CleanupStack::PushL(self);
    self->ConstructL(stream);
    return self;
}

// -----------------------------------------------------------------------------
CTsModelItemKeyMsg::~CTsModelItemKeyMsg()
{}

// -----------------------------------------------------------------------------
TTsModelItemKey CTsModelItemKeyMsg::key() const
{
    return mKey;
}

// -----------------------------------------------------------------------------
void CTsModelItemKeyMsg::InternalizeL(RReadStream &stream)
{
    stream >> mKey;
}

// -----------------------------------------------------------------------------
CTsModelItemKeyMsg::CTsModelItemKeyMsg()
{
    //no implementation required
}

// -----------------------------------------------------------------------------
void CTsModelItemKeyMsg::ConstructL(RReadStream &stream)
{
    stream >> (*this);
}

