/*
* Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This component and the accompanying materials are made available
* under the terms of "Eclipse Public License v1.0"
* which accompanies this distribution, and is available
* at the URL "http://www.eclipse.org/legal/epl-v10.html".
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/
#include <QDateTime>
#include <QStringList>

#include "tstestmodel.h"

const int dataIterations(3);

TsTestModel::TsTestModel()
{
    mData = data(-1);
}
QList<QVariantHash> TsTestModel::taskList() const
{
    return mData;
}

QList<QVariantHash> TsTestModel::taskList(int limit) const
{
    return data(limit);
}

bool TsTestModel::openTask(const QVariant &/*id*/)
{
    return true;
}
bool TsTestModel::closeTask(const QVariant &/*id*/) 
{
    return true;
}

QList<QVariantHash> TsTestModel::data(int limit) const
{
    QStringList allKeys;
    allKeys << "TaskId" << "TaskName" << "TaskScreenshot" << "TaskTimestamp" << "TaskIsRunning" << "TaskCanBeClosed" << "TaskUid";

    int offset(0);
    QList<QVariantHash> retVal;
    for( int iter(0); iter < dataIterations; ++iter) {
    
        if(-1 != limit && ++offset >limit) {
            break;
        }
        retVal.append(data());
        
        foreach (const QString &key, allKeys) {
            if(-1 != limit && ++offset >limit) {
                break;
            }
            QVariantHash dataSet(data());
            dataSet.remove(key);
            retVal.append(dataSet);
        }
    }
    return retVal;
}

QVariantHash TsTestModel::data()const
{
    QVariantHash data;
    data.insert("TaskId", 0);
    data.insert("TaskName", "Fake test name");
    data.insert("TaskScreenshot", 0);
    data.insert("TaskTimestamp", QDateTime());
    data.insert("TaskIsRunning", 0);
    data.insert("TaskCanBeClosed", 0);
    data.insert("TaskUid", 0 );
    return data;
}

