/*
* Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This component and the accompanying materials are made available
* under the terms of "Eclipse Public License v1.0"
* which accompanies this distribution, and is available
* at the URL "http://www.eclipse.org/legal/epl-v10.html".
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/

#include <QtTest/QtTest>
#include <qservicemanager.h>
#include "t_tsservicesproviderconfig.h"
#include "tsservicesproviderconfig.h"

const char serviceFile [] = ":/t_tsservicesproviderconfig.xml";
const char serviceName [] = "TsTestModelPlugin";
void T_TsServiceProviderConfig::testConfig()
{
    CTsServiceProviderConfig *cfg(0);
    
    //test doesnt install any plugin. number of services can be equal 0
    cfg = CTsServiceProviderConfig::NewLC();
    QVERIFY(0 <= cfg->count());
    QVERIFY(checkInterfaces(*cfg));
    CleanupStack::PopAndDestroy(cfg);
    
    //test install test plugin. number of services has to be bigger then 0
    QTM_NAMESPACE::QServiceManager manager;
    manager.addService(serviceFile);
    cfg = CTsServiceProviderConfig::NewLC();
    QVERIFY(0 < cfg->count());
    QVERIFY(checkInterfaces(*cfg));
    CleanupStack::PopAndDestroy(cfg);
    manager.removeService(serviceName);
}

bool T_TsServiceProviderConfig::checkInterfaces(const CTsServiceProviderConfig & cfg)
{
    bool retVal(true);
    for(int iter(0); iter < cfg.count() && retVal; ++iter) {
        QObject* ptr = cfg.loadL(iter);
        retVal = (0 != ptr);
        delete ptr;
    }
    return retVal;
}

QTEST_MAIN(T_TsServiceProviderConfig)
