/*
 * Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
 * All rights reserved.
 * This component and the accompanying materials are made available
 * under the terms of "Eclipse Public License v1.0"
 * which accompanies this distribution, and is available
 * at the URL "http://www.eclipse.org/legal/epl-v10.html".
 *
 * Initial Contributors:
 * Nokia Corporation - initial contribution.
 *
 * Contributors:
 *
 * Description:
 *
 */

#include "testservicehandler.h"



TestServiceHandler::TestServiceHandler(QObject *parent):
    XQServiceProvider(QLatin1String("com.nokia.services.embeddedservices.requestSetTitle"), parent),
    mCurrentRequestIndex(0), mTitle("Embedded")
{
    publishAll();
}

TestServiceHandler::~TestServiceHandler()
{
}

void TestServiceHandler::completeRequestSetTitle(const QString& title)
{
    QVariant retValue;
    retValue.setValue(title);
    bool ok = completeRequest(mCurrentRequestIndex, retValue);
    mCurrentRequestIndex = 0;
}


void TestServiceHandler::requestSetTitle(const QString &title)
{
    mTitle = title;
    mCurrentRequestIndex = setCurrentRequestAsync();
    emit launchSetTitle(title);
}

QString TestServiceHandler::title()
{
    return mTitle;
}

