/*
 * Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
 * All rights reserved.
 * This component and the accompanying materials are made available
 * under the terms of "Eclipse Public License v1.0"
 * which accompanies this distribution, and is available
 * at the URL "http://www.eclipse.org/legal/epl-v10.html".
 *
 * Initial Contributors:
 * Nokia Corporation - initial contribution.
 *
 * Contributors:
 *
 * Description:
 *
 */

#ifndef TESTSERVICEHANDLER_H
#define TESTSERVICEHANDLER_H

#include <xqserviceprovider.h>
#include <xqservicemanager.h>
#include <qservicemanager.h>

QTM_USE_NAMESPACE

class TestServiceHandler : public XQServiceProvider
{
    Q_OBJECT
public:
    TestServiceHandler(QObject *parent = 0);
    ~TestServiceHandler();

public:
    void completeRequestSetTitle(const QString& title);
    QString title();

public slots:
    // Services offered to clients
    void requestSetTitle(const QString &title);
    
signals:
    void launchSetTitle(const QString &title);   


private:
    int mCurrentRequestIndex;
    QString mTitle;
};

#endif /* TESTSERVICEHANDLER_H */
