/*
* Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This component and the accompanying materials are made available
* under the terms of "Eclipse Public License v1.0"
* which accompanies this distribution, and is available
* at the URL "http://www.eclipse.org/legal/epl-v10.html".
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/
#ifndef LUNCWIDGET_H_
#define LUNCWIDGET_H_

#include <hbwidget.h>
#include <QGraphicsGridLayout>
#include <HbPushButton>
#include <hblabel.h>
#include <qservicemanager.h>


QTM_USE_NAMESPACE

class lunchwidget: public HbWidget
{
    Q_OBJECT
public:
    lunchwidget(QGraphicsItem *parent = 0);
    ~lunchwidget();

private:

    QGraphicsGridLayout *mGridLayout;
    HbPushButton *mActivationButton;
    HbPushButton *mProviderButton;
    HbLabel* mResultLabel;    
    QServiceManager* mManager;

private slots:
    void lunchActivation();
    void lunchProvider();
    
    void setError(bool ok, int err);        
};

#endif /* LUNCWIDGET_H_*/
